## ͻƾ   Falcon.SugarApi.ClaimTicket.ClaimTicket

### 1ClaimTicket֧֡   
  ǷʹClaimTicketɲо   
  ҪʹClaimTicket·ʽڲӡ  
~~~C#
public class ServicePlugin:IServicePlugin
{
    IServiceCollection IServicePlugin.AddServices(IServiceCollection services,IConfiguration configuration) {
        //עʹClaimTicketĿ
        services.AddPluginsController(this.GetType().Assembly);
        //ClaimTicket֧
        services.AddClaimTicket();
        return services;
    }
}

~~~   

### 2ע  
  Ҫûĵ¼֤Ͱ󶨹ҪעITicketBuilderӿڣӿservices.AddClaimTicket()Ѿע롣  
  HomeControllerעITicketBuilderʾ  
~~~C#   

public ITicketBuilder TicketBuilder { get; set; }

public HomeController(IServiceProvider service) : base(service) {
    this.TicketBuilder = service.GetRequiredService<ITicketBuilder>();
}
~~~   
### 3û¼
  Ҫû֤ʾ¡   
~~~c#
[HttpGet]
public string Login(string username) {
    //֤ûЧԣеݿ֤

    //֤ͨûƱ
    var user = new UserTicket(
            //û
            new Claim("name",username),
            //Ҫ
            new Claim("role","admin")
    );
    var ticket = this.TicketBuilder.GetTicket(user);
    return ticket ?? "";
}

~~~
ͻյصƱݺбƱݡ   

### 4֤û   
ʵ£
~~~c#   
[HttpGet]
public string ViewUser(string ticket) {
    //ͨƱݻȡû
    var cs = this.TicketBuilder.GetUser(ticket);
    if(cs == null) {
        return "TicketBuilder.GetUser ؿ";
    }
    StringBuilder sb = new();
    //ѵƱɻȡ¼Ϣ
    foreach(var i in cs.Claims) {
        sb.AppendLine($"type:{i.Type},Val:{i.Value}");
    }
    return sb.ToString();
}

~~~   
### 5û    
ʾ:
~~~c#
[HttpGet]
public string Viewbind(string _authUserTicket,[FromHeader] UserTicket user) {
    StringBuilder sb = new();
    foreach(var i in user.Claims) {
        sb.AppendLine($"type:{i.Type},Val:{i.Value}");
    }
    return sb.ToString();
}
~~~    
һͻͨHTTPͷ_authUserTicketύûƾݣΪ˷ͨgetύƱݣԶUserTicketС  
Ϊactionͨhttpbodyȡһ_authUserTicketUserTicketҪ[FromHeader]ԡ   

## ϹͿʹˣʱǻһЩ󣬿ͨķʽչ  

### 6ԶClaimTicket   
ͨClaimTicketOptionsáõ;  
> 1ڲעԼClaimTicketOptions
> ~~~c#
> public class ServicePlugin:IServicePlugin
> {
>     IServiceCollection IServicePlugin.AddServices(IServiceCollection services,IConfiguration configuration) {
>         //עʹClaimTicketĿ
>         services.AddPluginsController(this.GetType().Assembly);
> 
>         //Լķ
>         services.AddSingleton(new ClaimTicketOptions());
> 
>         //ClaimTicket֧
>         services.AddClaimTicket();
>         return services;
>     }
> }
> ~~~
> 2services.AddClaimTicketдClaimTicketOptions
> ~~~c#
> public class ServicePlugin:IServicePlugin
> {
>     IServiceCollection IServicePlugin.AddServices(IServiceCollection services,IConfiguration configuration) {
>         //עʹClaimTicketĿ
>         services.AddPluginsController(this.GetType().Assembly);
> 
>         //Լķ
>         //services.AddSingleton(new ClaimTicketOptions());
> 
>         //ClaimTicket֧
>         services.AddClaimTicket(optionsBuilder => {
>             //ͻͨ_headCalimTickύƾ
>             optionsBuilder.HttpHeaderKey = "_headCalimTick";
>         });
>         return services;
>     }
> }
> ~~~   
### 7չITicketBuilder  
չƱݵɷʽһǼ̳TicketBuilderдһԼʵITicketBuilderӿڡ  

~~~c#
/// <summary>
/// ԶƱɷʽ
/// </summary>
public class MyTicketBuilder:TicketBuilder, ITicketBuilder
{
    /// <summary>
    /// ʹƱݲ
    /// </summary>
    /// <param name="options">ɲ</param>
    public MyTicketBuilder(ClaimTicketOptions options) : base(options) { }

    /// <inheritdoc/>
    public override string? GetTicket(UserTicket userTicket) {
        //ʵԼƱɷ
            
        //ʹûṩķ
        return base.GetTicket(userTicket);
    }

    /// <inheritdoc/>
    public override UserTicket? GetUser(string ticket) {
        //ƱݻȡûûϢ

        //ʹûṩķ
        return base.GetUser(ticket);
    }
}
~~~
ȻڵAddClaimTicket֮ǰעԼITicketBuilder
~~~c#
public class ServicePlugin:IServicePlugin
{
    IServiceCollection IServicePlugin.AddServices(IServiceCollection services,IConfiguration configuration) {
        //עʹClaimTicketĿ
        services.AddPluginsController(this.GetType().Assembly);

        //Լķ
        //services.AddSingleton(new ClaimTicketOptions());

        //עչMyTicketBuilder
        services.TryAddSingleton<ITicketBuilder,MyTicketBuilder>();

        //ClaimTicket֧
        services.AddClaimTicket(optionsBuilder => {
            //ͻͨ_headCalimTickύƾ
            optionsBuilder.HttpHeaderKey = "_headCalimTick";
        });
        return services;
    }
}

~~~
### 8չUserTicket  
UserTicket̳ʵԼû࣬´ʵԼMyUserTicket࣬һVerԡ  
~~~c#
public class MyUserTicket:UserTicket
{
    public MyUserTicket() {}

    public int Ver { get; set; }

    public MyUserTicket(UserTicket? user) {
        this.Claims = user?.Claims;
    }
}
~~~
ȻҪʵԼITicketBuilderʵ֣ΪUserTicket֪δVer  
~~~c#
/// <summary>
/// ԶƱɷʽ
/// </summary>
public class MyTicketBuilder:TicketBuilder, ITicketBuilder
{
    /// <summary>
    /// ʹƱݲ
    /// </summary>
    /// <param name="options">ɲ</param>
    public MyTicketBuilder(ClaimTicketOptions options,IEncryption encryption,IJsonSerialize serialize)
        : base(options,encryption,serialize) { }

    /// <inheritdoc/>
    public override string? GetTicket(UserTicket userTicket) {
        //ʵԼƱɷ
        if(userTicket is MyUserTicket mut) {
            var obj = mut.Claims.Select(a => new ClaimKeyValue { Key = a.Type,Value = a.Value });
            var ll = obj.ToList();
            ll.Add(new ClaimKeyValue { Key = "Ver",Value = mut.Ver.ToString() });
            var str = this.Serialize.Serialize(ll);
            var code = this.Encryption.Encrypt(this.Options.EncryptionKey,str);
            return code;
        }
        //ʹûṩķ
        return base.GetTicket(userTicket);
    }

    /// <inheritdoc/>
    public override UserTicket? GetUser(string ticket) {
        //ƱݻȡûûϢ
        var str = this.Encryption.Decrypt(this.Options.EncryptionKey,ticket);
        if(str.IsNullOrEmpty()) {
            return new MyUserTicket();
        }
        var list = this.Serialize.Deserialize<List<ClaimKeyValue>>(str);
        if(list == null) {
            return new MyUserTicket();
        }
        var ut = new UserTicket(list.Select(a => new Claim(a.Key,a.Value)));
        var result = new MyUserTicket(ut);
        var verf = list.Find(a => a.Key == "Ver");
        if(verf != null) {
            result.Ver = int.Parse(verf.Value);
        }
        //ʹûṩķ
        return result as UserTicket;
    }
}
~~~   
ȻʹķʽITicketBuilderע   
žڵ¼ʱʹԼƱ   
~~~c#
public string Login(string username) {
    //֤ûЧԣеݿ֤

    //֤ͨûƱ
    var user = new UserTicket(
            //û
            new Claim("name",username),
            //Ҫ
            new Claim("role","admin")
    );
    var muser = new MyUserTicket(user);
    //Լ
    muser.Ver = 5;
    var ticket = this.TicketBuilder.GetTicket(muser);
    return ticket ?? "";
}

~~~   
ʹõʱֱע룺  
~~~c#
public string Viewbind(string _authUserTicket,[FromHeader] MyUserTicket? user) {
    if(user == null) {
        return "ʧܣ";
    }
    StringBuilder sb = new();
    foreach(var i in user.Claims) {
        sb.AppendLine($"type:{i.Type},Val:{i.Value}");
    }
    sb.AppendLine($"user.Ver={user.Ver}");
    return sb.ToString();
}
~~~
